﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GameExample.Model
{
    class GameEngine
    {
        public event Action StateIsUpdated;
        public Player Player { get; set; }
        GameBoard gameBoard;
        public Housefly Fly { get; set; }

        
        public int Score { get; private set; } = 0;


        public GameEngine(int width, int height)
        {
            gameBoard = new GameBoard(height,width);
            
            //pisyje z palca - brzydkie bardzo
            Player = new Player("kokoJambo", "Jan", "Jop");
            Player.Shoot += Player_Shoot;
            Fly = new Housefly(new int[] { gameBoard.Height, gameBoard.Width } ,30, 30);
            Fly.ChangedPosition += Fly_ChangedPosition;
        }

        private void Player_Shoot(int x, int y)
        {
            if (x >= Fly.Position[0] && x <= Fly.Position[0] + Fly.Height && y >= Fly.Position[1] && y <= Fly.Position[1] + Fly.Width)
            {
                Score++;

            }
        }

        private void Fly_ChangedPosition()
        {
            StateIsUpdated?.Invoke();
        }

        public void Start()
        {
            Fly.IsFlying = true;
        }
    }
}
