﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GameExample
{
    using Model;
    class Presenter
    {
        IView _view;
        GameEngine _game;

        public Presenter(IView view, GameEngine gameEngine)
        {
            _view = view;
            _view.Start += _view_Start;
            _view.Shoting += _view_Shoting;
            _game = gameEngine;
            _game.StateIsUpdated += _game_Updated;
        }

        private void _view_Shoting(int x, int y)
        {
            _game.Player.Shot(x,y);
        }

        private void _view_Start()
        {
            _game.Start();
        }

        private void _game_Updated()
        {
            _view.DrawFly(_game.Fly.Position[0], _game.Fly.Position[1]);
            _view.Score = _game.Score;
        }
    }
}
